/**************************************************************
	12F629/12F675
	Electric sand timer
	dqv

	author air_variable June,17,2007
	version 1.10
	1.10 20070816 correspondeng economy mode
	Tools:
	MPLAB 7.60a
	Hitech PICC Lite v9.60

	Pin assignment:
	(1)Vdd					[PICKIT2-2] 
	(2)GPIO5	LED RED(neg)
	(3)NC
	(4)reset				[PICKIT2-1]	(Vpp) Vdd bitween resister 10Kohm
	(5)GPIO4	Piezo(neg)
	(6)GPIO1				[PICKIT2-5]
	(7)GPIO0				[PICKIT2-4]
	(8)Vss					[PICKIT2-3]

	
	PDdr܂BႢr[vҋ@ԂłB
	QDsG]fqɌyՌ^ƁALED_܂B
	̍ŒɂxՌ^ƁAr[vn߁AvJn܂B
	RDPb݂ŃNbNA1ɏłȂ܂B
	SDK莞ԁĩvOł͂RjoƁAԌo߂\A
	LED2b_Aҋ@Ԃɖ߂܂B

**************************************************************/

#include <htc.h>
#include "delay.h"
#define LED_RED		GPIO5	//active low
#define PIEZO		GPIO2	//active low
#define SET_TIMER	3		//timer 3 minute
#define RESULT_BEEP	10		//result of beep times 10 times
#define Delay_1s	DelayMs(250);	\
					DelayMs(250);	\
					DelayMs(250);	\
					DelayMs(250);	\


__CONFIG(0x3FA4);	//InternalClockNoCLKOUT,WatchdogOff,PowerUpTimerOn,MasterClearEnableInternal,
					//BrownOutOff//CodeProtectOff,EEProtectOff

//Beep sound 4KHz--------------------------------
void beep_sound4k(unsigned int timer)
{
	while(timer--){
		PIEZO =0;
		DelayUs(120);
		PIEZO =1;
		DelayUs(120);
	}	
}
//Beep sound 2KHz--------------------------------
void beep_sound2k(unsigned int timer)
{
	while(timer--){
		PIEZO =0;
		DelayUs(255);
		PIEZO =1;
		DelayUs(255);
	}	
}
//Beep click sound --------------------------------
void beep_click(void)
{
	unsigned char temp=10;
	while(temp--){
		PIEZO =0;
		DelayUs(64);
		PIEZO =1;
		DelayUs(64);
	}	
}

//------------------main
main()
{
 	unsigned int	temp;
	unsigned char	temp1,temp2,nextflag;

//---------------------------------------------------------
//Initialization
	OSCCAL = _READ_OSCCAL_DATA();	//OSCCAL AUTO SET
	GIE  = 0;						//Interrupt service is disable
	CMCON  = 7;						//GPIO use all digital port

#if _12F675
    ANSEL  =  	  0b00000000;		//when device is 12F675
#endif
				//  76543210
    TRISIO 	=     0b00001000;		//GPIO2 is OUTPUT
    GPIO	=     0b00001000;		//GPIO initialize

//---------------------------------------------------------
//Start up routiene
//power on opening Beep
	beep_sound2k(1000);

//Sleep check loop
	while(1){
		nextflag=1;					//sleep escape flag
		do
		{
//setup to sleep routiene
					//  76543210
		    TRISIO 	= 0b00111111;	//GPIO is all input listen mode
			GPPU =  0;				//internal pullup function use
			WPU  =	  0b00110111;	//Pull up port select (ALL Pin Pull Up as low power)
			IOCB =    0b00000100;	//GPIO0 is listen mode
		    GPIO	= 0b00001100;	//GPIO setting (Piezo port is 1)
			DelayMs(50);			//stabilize time
			GPIO = GPIO;			//Flash port
			GPIF  = 0;				//GPIF flag clear
			GPIE  = 1;				//sleep wake-up function is enable
									//vector non jump and execute next command
			SLEEP();				//sleep!
			NOP();					//Wake up
//--Wake-up start!
		    TRISIO 	= 0b00001000;	//LED out  and PIEZO INIT
		    GPIO	= 0b00001100;	//GPIO initialize
		    TRISIO 	= 0b00001100;	//LED out  and PIEZO input
		    GPIO	= 0b00001100;	//GPIO initialize 
			DelayMs(10);			//waiting stabilize port time

//Detect of Double cleck
			temp =30000;
			do{
				DelayUs(1);			//wait
				if (PIEZO==0) { 	//twice impact of piezo?
					nextflag=0; 	//yes! twice impact .Pull out loop of sleep.
					break;
				}
			}while(temp--);			//check loop
			
		}while (nextflag);			//dropout

			
// Wakeup when GPIO0 is high 
	
		GPIE  = 0;	//sleep wake-up function is disable
		GPIF  = 0;	//GPIO int flag reset
		GPPU  = 1;	//internal pullup function disable
	
	    TRISIO 	= 0b00001000;	//GPIO0 is OUTPUT
	    GPIO	= 0b00001000;	//GPIO initialize

//---------------------------------------------------------
//Begin at timer

		beep_sound4k(1000);
//Timer counter
		temp2 = SET_TIMER;		//minute
		while(temp2--){
			temp = 60;			//second count
//1sec timer
			while(temp--){
				LED_RED = 0;	//LED light
				DelayMs(250);
				LED_RED = 1;	//LED off
				DelayMs(250);
				DelayMs(250);
				DelayMs(233);	//adjustment total 1s
				beep_click();	//1 second sound click
			}
		beep_sound4k(10);		//1 minute sound click
		}
//---------------------------------------------------------
//End of timer routiene
//Buzzer OUT (4KHz)
		LED_RED = 0;
		temp2 = RESULT_BEEP; //Beep
		while(temp2--){
			beep_sound4k(300);
			DelayMs(250);
			DelayMs(250);// Beep silent
		}

	Delay_1s;
	Delay_1s;

	}
}
		
